diff --git a/ent/src/yb/cdc/cdcsdk_producer.cc b/ent/src/yb/cdc/cdcsdk_producer.cc
index 1bf015a85733..40bcedd35e24 100644
--- a/ent/src/yb/cdc/cdcsdk_producer.cc
+++ b/ent/src/yb/cdc/cdcsdk_producer.cc
@@ -208,7 +208,8 @@ Status PopulateBeforeImage(
   auto tablet = tablet_peer->shared_tablet();
   auto docdb = tablet->doc_db();
 
-  docdb::DocReadContext doc_read_context(schema, schema_version);
+  const auto log_prefix = tablet->LogPrefix();
+  docdb::DocReadContext doc_read_context(log_prefix, schema, schema_version);
   docdb::DocRowwiseIterator iter(
       schema, doc_read_context, TransactionOperationContext(), docdb,
       CoarseTimePoint::max() /* deadline */, read_time);
diff --git a/ent/src/yb/master/restore_sys_catalog_state.cc b/ent/src/yb/master/restore_sys_catalog_state.cc
index 8ee2ba1f8e2a..ec84632bdf1e 100644
--- a/ent/src/yb/master/restore_sys_catalog_state.cc
+++ b/ent/src/yb/master/restore_sys_catalog_state.cc
@@ -56,7 +56,9 @@ namespace {
 Status ApplyWriteRequest(
     const Schema& schema, const QLWriteRequestPB& write_request,
     docdb::DocWriteBatch* write_batch) {
-  auto doc_read_context = std::make_shared<docdb::DocReadContext>(schema, kSysCatalogSchemaVersion);
+  const std::string kLogPrefix = "restored tablet: ";
+  auto doc_read_context = std::make_shared<docdb::DocReadContext>(
+      kLogPrefix, schema, kSysCatalogSchemaVersion);
   docdb::DocOperationApplyData apply_data{
       .doc_write_batch = write_batch, .deadline = {}, .read_time = {}, .restart_read_ht = nullptr};
   IndexMap index_map;
diff --git a/src/yb/docdb/CMakeLists.txt b/src/yb/docdb/CMakeLists.txt
index 3b2969ee49db..51bd40fce740 100644
--- a/src/yb/docdb/CMakeLists.txt
+++ b/src/yb/docdb/CMakeLists.txt
@@ -81,6 +81,7 @@ set(DOCDB_SRCS
         doc_pg_expr.cc
         doc_pgsql_scanspec.cc
         doc_ql_scanspec.cc
+        doc_read_context.cc
         doc_rowwise_iterator.cc
         doc_write_batch_cache.cc
         doc_write_batch.cc
diff --git a/src/yb/docdb/doc_operation-test.cc b/src/yb/docdb/doc_operation-test.cc
index b1ad584805c4..1109dff3eb48 100644
--- a/src/yb/docdb/doc_operation-test.cc
+++ b/src/yb/docdb/doc_operation-test.cc
@@ -181,9 +181,9 @@ class DocOperationTest : public DocDBTestBase {
                const TransactionOperationContext& txn_op_context =
                    kNonTransactionalOperationContext) {
     IndexMap index_map;
-    QLWriteOperation ql_write_op(ql_writereq_pb,
-                                 std::make_shared<DocReadContext>(schema, 1),
-                                 index_map, nullptr /* unique_index_key_schema */, txn_op_context);
+    QLWriteOperation ql_write_op(
+        ql_writereq_pb, std::make_shared<DocReadContext>(DocReadContext::TEST_Create(schema)),
+        index_map, nullptr /* unique_index_key_schema */, txn_op_context);
     ASSERT_OK(ql_write_op.Init(ql_writeresp_pb));
     auto doc_write_batch = MakeDocWriteBatch();
     HybridTime restart_read_ht;
@@ -327,7 +327,7 @@ SubDocKey(DocKey(0x0000, [1], []), [ColumnId(3); HT{ <max> w: 2 }]) -> 4
     WriteBuffer rows_data(1024);
     QLResultSet resultset(&rsrow_desc, &rows_data);
     HybridTime read_restart_ht;
-    DocReadContext doc_read_context(schema, 1);
+    auto doc_read_context = DocReadContext::TEST_Create(schema);
     EXPECT_OK(read_op.Execute(
         ql_storage, CoarseTimePoint::max() /* deadline */, ReadHybridTime::SingleTime(read_time),
         doc_read_context, projection, &resultset, &read_restart_ht));
@@ -560,7 +560,7 @@ SubDocKey(DocKey(0x0000, [100], []), [ColumnId(3); HT{ physical: 0 logical: 3000
       )#");
 
   Schema schema = CreateSchema();
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
   DocRowwiseIterator iter(schema, doc_read_context, kNonTransactionalOperationContext,
                           doc_db(), CoarseTimePoint::max() /* deadline */,
                           ReadHybridTime::FromUint64(3000));
@@ -786,7 +786,8 @@ class DocOperationScanTest : public DocOperationTest {
     ColumnSchema range_column("r", INT32, false, false, false, false, 1, range_column_sorting);
     ColumnSchema value_column("v", INT32, false, false);
     auto columns = { hash_column, range_column, value_column };
-    doc_read_context_ = DocReadContext(Schema(columns, CreateColumnIds(columns.size()), 2), 1);
+    doc_read_context_ = DocReadContext::TEST_Create(
+        Schema(columns, CreateColumnIds(columns.size()), 2));
   }
 
   void InsertRows(const size_t num_rows_per_key,
@@ -936,7 +937,7 @@ class DocOperationScanTest : public DocOperationTest {
 
   std::mt19937_64 rng_;
   SortingType range_column_sorting_type_;
-  DocReadContext doc_read_context_{Schema(), 1};
+  DocReadContext doc_read_context_ = DocReadContext::TEST_Create(Schema());
   int32_t h_key_;
   std::vector<RowDataWithHt> rows_;
 };
diff --git a/src/yb/docdb/doc_read_context.cc b/src/yb/docdb/doc_read_context.cc
new file mode 100644
index 000000000000..18dc7096ee18
--- /dev/null
+++ b/src/yb/docdb/doc_read_context.cc
@@ -0,0 +1,60 @@
+// Copyright (c) YugaByte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+//
+
+#include "yb/docdb/doc_read_context.h"
+
+#include "yb/util/logging.h"
+
+namespace yb::docdb {
+
+DocReadContext::DocReadContext(const std::string& log_prefix)
+    : log_prefix_(log_prefix) {
+}
+
+DocReadContext::DocReadContext(const std::string& log_prefix, const Schema& schema_,
+                               SchemaVersion schema_version)
+    : schema(schema_), log_prefix_(log_prefix) {
+  schema_packing_storage.AddSchema(schema_version, schema_);
+  LOG_WITH_PREFIX(INFO) << "DocReadContext, from schema, version: " << schema_version;
+}
+
+DocReadContext::DocReadContext(
+    const DocReadContext& rhs, const Schema& schema_, SchemaVersion schema_version)
+    : schema(schema_), schema_packing_storage(rhs.schema_packing_storage),
+      log_prefix_(rhs.log_prefix_) {
+  schema_packing_storage.AddSchema(schema_version, schema_);
+  LOG_WITH_PREFIX(INFO)
+      << "DocReadContext, copy and add: " << schema_packing_storage.VersionsToString()
+      << ", added: " << schema_version;
+}
+
+DocReadContext::DocReadContext(const DocReadContext& rhs, SchemaVersion min_schema_version)
+    : schema(rhs.schema), schema_packing_storage(rhs.schema_packing_storage, min_schema_version),
+      log_prefix_(rhs.log_prefix_) {
+  LOG_WITH_PREFIX(INFO)
+      << "DocReadContext, copy and filter: " << rhs.schema_packing_storage.VersionsToString()
+      << " => " << schema_packing_storage.VersionsToString() << ", min_schema_version: "
+      << min_schema_version;
+}
+
+void DocReadContext::LogAfterLoad() {
+  LOG_WITH_PREFIX(INFO) << __func__ << ": " << schema_packing_storage.VersionsToString();
+}
+
+void DocReadContext::LogAfterMerge(OverwriteSchemaPacking overwrite) {
+  LOG_WITH_PREFIX(INFO)
+      << __func__ << ": " << schema_packing_storage.VersionsToString() << ", overwrite: "
+      << overwrite;
+}
+
+} // namespace yb::docdb
diff --git a/src/yb/docdb/doc_read_context.h b/src/yb/docdb/doc_read_context.h
index 4da7ad90420a..0a993b2fc220 100644
--- a/src/yb/docdb/doc_read_context.h
+++ b/src/yb/docdb/doc_read_context.h
@@ -21,33 +21,30 @@ namespace yb {
 namespace docdb {
 
 struct DocReadContext {
-  DocReadContext() = default;
+  explicit DocReadContext(const std::string& log_prefix);
 
-  DocReadContext(const Schema& schema_, SchemaVersion schema_version) : schema(schema_) {
-    schema_packing_storage.AddSchema(schema_version, schema_);
-  }
+  DocReadContext(
+      const std::string& log_prefix, const Schema& schema_, SchemaVersion schema_version);
 
-  DocReadContext(const DocReadContext& rhs, const Schema& schema_, SchemaVersion schema_version)
-      : schema(schema_), schema_packing_storage(rhs.schema_packing_storage) {
-    schema_packing_storage.AddSchema(schema_version, schema_);
-  }
+  DocReadContext(const DocReadContext& rhs, const Schema& schema_, SchemaVersion schema_version);
 
-  DocReadContext(const DocReadContext& rhs, SchemaVersion min_schema_version)
-      : schema(rhs.schema), schema_packing_storage(rhs.schema_packing_storage, min_schema_version) {
-  }
+  DocReadContext(const DocReadContext& rhs, SchemaVersion min_schema_version);
 
   template <class PB>
   Status LoadFromPB(const PB& pb) {
     RETURN_NOT_OK(SchemaFromPB(pb.schema(), &schema));
     RETURN_NOT_OK(schema_packing_storage.LoadFromPB(pb.old_schema_packings()));
     schema_packing_storage.AddSchema(pb.schema_version(), schema);
+    LogAfterLoad();
     return Status::OK();
   }
 
   template <class PB>
   Status MergeWithRestored(const PB& pb, OverwriteSchemaPacking overwrite) {
-    return schema_packing_storage.MergeWithRestored(
-        pb.schema_version(), pb.schema(), pb.old_schema_packings(), overwrite);
+    RETURN_NOT_OK(schema_packing_storage.MergeWithRestored(
+        pb.schema_version(), pb.schema(), pb.old_schema_packings(), overwrite));
+    LogAfterMerge(overwrite);
+    return Status::OK();
   }
 
   template <class PB>
@@ -63,8 +60,22 @@ struct DocReadContext {
         lhs.schema_packing_storage == rhs.schema_packing_storage;
   }
 
+  static DocReadContext TEST_Create(const Schema& schema) {
+    return DocReadContext("TEST: ", schema, 1);
+  }
+
   Schema schema;
   SchemaPackingStorage schema_packing_storage;
+
+ private:
+  void LogAfterLoad();
+  void LogAfterMerge(OverwriteSchemaPacking overwrite);
+
+  const std::string& LogPrefix() const {
+    return log_prefix_;
+  }
+
+  std::string log_prefix_;
 };
 
 } // namespace docdb
diff --git a/src/yb/docdb/docdb_util.cc b/src/yb/docdb/docdb_util.cc
index 173ed749b769..95b7801a9f70 100644
--- a/src/yb/docdb/docdb_util.cc
+++ b/src/yb/docdb/docdb_util.cc
@@ -42,6 +42,12 @@ using std::vector;
 namespace yb {
 namespace docdb {
 
+namespace {
+
+const std::string kEmptyLogPrefix;
+
+}
+
 Status SetValueFromQLBinaryWrapper(
     QLValuePB ql_value, const int pg_data_type,
     const std::unordered_map<uint32_t, string>& enum_oid_label_map,
@@ -51,10 +57,10 @@ Status SetValueFromQLBinaryWrapper(
       ql_value, pg_data_type, enum_oid_label_map, composite_atts_map, cdc_datum_message);
 }
 
-DocDBRocksDBUtil::DocDBRocksDBUtil() : doc_read_context_(Schema(), 1) {}
+DocDBRocksDBUtil::DocDBRocksDBUtil() : doc_read_context_(kEmptyLogPrefix, Schema(), 1) {}
 
 DocDBRocksDBUtil::DocDBRocksDBUtil(InitMarkerBehavior init_marker_behavior)
-    : doc_read_context_(Schema(), 1), init_marker_behavior_(init_marker_behavior) {
+    : doc_read_context_(kEmptyLogPrefix, Schema(), 1), init_marker_behavior_(init_marker_behavior) {
 }
 
 rocksdb::DB* DocDBRocksDBUtil::rocksdb() {
diff --git a/src/yb/docdb/docrowwiseiterator-test.cc b/src/yb/docdb/docrowwiseiterator-test.cc
index 4d8305ebb47c..1349e5424352 100644
--- a/src/yb/docdb/docrowwiseiterator-test.cc
+++ b/src/yb/docdb/docrowwiseiterator-test.cc
@@ -299,7 +299,7 @@ void DocRowwiseIteratorTest::InsertTestRangeData() {
 
 void DocRowwiseIteratorTest::TestClusteredFilterRange() {
   InsertTestRangeData();
-  DocReadContext doc_read_context(test_range_schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(test_range_schema);
 
   const std::vector<KeyEntryValue> hashed_components{KeyEntryValue::Int32(5)};
 
@@ -348,7 +348,7 @@ void DocRowwiseIteratorTest::TestClusteredFilterRange() {
 
 void DocRowwiseIteratorTest::TestClusteredFilterHybridScan() {
   InsertPopulationData();
-  DocReadContext doc_read_context(population_schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(population_schema);
 
   const std::vector<KeyEntryValue> hashed_components{KeyEntryValue(INDIA)};
 
@@ -431,7 +431,7 @@ void DocRowwiseIteratorTest::TestClusteredFilterHybridScan() {
 
 void DocRowwiseIteratorTest::TestClusteredFilterSubsetCol() {
   InsertPopulationData();
-  DocReadContext doc_read_context(population_schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(population_schema);
 
   const std::vector<KeyEntryValue> hashed_components{KeyEntryValue(INDIA)};
 
@@ -556,7 +556,7 @@ void DocRowwiseIteratorTest::TestClusteredFilterSubsetCol() {
 
 void DocRowwiseIteratorTest::TestClusteredFilterSubsetCol2() {
   InsertPopulationData();
-  DocReadContext doc_read_context(population_schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(population_schema);
 
   const std::vector<KeyEntryValue> hashed_components{KeyEntryValue(INDIA)};
 
@@ -635,7 +635,7 @@ void DocRowwiseIteratorTest::TestClusteredFilterSubsetCol2() {
 
 void DocRowwiseIteratorTest::TestClusteredFilterMultiIn() {
   InsertPopulationData();
-  DocReadContext doc_read_context(population_schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(population_schema);
 
   const std::vector<KeyEntryValue> hashed_components{KeyEntryValue(INDIA)};
 
@@ -723,7 +723,7 @@ void DocRowwiseIteratorTest::TestClusteredFilterMultiIn() {
 
 void DocRowwiseIteratorTest::TestClusteredFilterEmptyIn() {
   InsertPopulationData();
-  DocReadContext doc_read_context(population_schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(population_schema);
 
   const std::vector<KeyEntryValue> hashed_components{KeyEntryValue(INDIA)};
 
@@ -810,7 +810,7 @@ void DocRowwiseIteratorTest::TestDocRowwiseIterator() {
   const Schema &projection = kProjectionForIteratorTests;
   QLTableRow row;
   QLValue value;
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -922,7 +922,7 @@ void DocRowwiseIteratorTest::TestDocRowwiseIteratorDeletedDocument() {
 
   const Schema &schema = kSchemaForIteratorTests;
   const Schema &projection = kProjectionForIteratorTests;
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -979,7 +979,7 @@ SubDocKey(DocKey([], ["row2", 22222]), [ColumnId(40); HT{ physical: 2800 w: 1 }]
 
   const Schema &schema = kSchemaForIteratorTests;
   const Schema &projection = kProjectionForIteratorTests;
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -1194,7 +1194,7 @@ SubDocKey(DocKey([], ["row1", 11111]), [ColumnId(50); HT{ physical: 2800 }]) ->
 
   const Schema &schema = kSchemaForIteratorTests;
   const Schema &projection = kProjectionForIteratorTests;
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -1243,7 +1243,7 @@ void DocRowwiseIteratorTest::TestDocRowwiseIteratorIncompleteProjection() {
   const Schema &schema = kSchemaForIteratorTests;
   Schema projection;
   ASSERT_OK(kSchemaForIteratorTests.CreateProjectionByNames({"c", "d"}, &projection));
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -1304,7 +1304,7 @@ SubDocKey(DocKey(ColocationId=16385, [], ["row1", 11111]), [SystemColumnId(0); \
   Schema schema_copy = kSchemaForIteratorTests;
   schema_copy.set_colocation_id(colocation_id);
   Schema projection;
-  DocReadContext doc_read_context(schema_copy, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema_copy);
 
   // Read should have results before delete...
   {
@@ -1376,7 +1376,7 @@ SubDocKey(DocKey([], ["row2", 22222]), [ColumnId(50); HT{ physical: 2800 w: 3 }]
   const Schema &schema = kSchemaForIteratorTests;
   Schema projection;
   ASSERT_OK(kSchemaForIteratorTests.CreateProjectionByNames({"c", "e"}, &projection));
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -1442,7 +1442,7 @@ void DocRowwiseIteratorTest::TestDocRowwiseIteratorValidColumnNotInProjection()
   const Schema &schema = kSchemaForIteratorTests;
   Schema projection;
   ASSERT_OK(kSchemaForIteratorTests.CreateProjectionByNames({"c", "d"}, &projection));
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -1498,7 +1498,7 @@ SubDocKey(DocKey([], ["row1", 11111]), [ColumnId(50); HT{ physical: 1000 w: 1 }]
   Schema projection;
   ASSERT_OK(kSchemaForIteratorTests.CreateProjectionByNames({"a", "b"},
       &projection, 2));
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -1657,7 +1657,7 @@ TXN REV 30303030-3030-3030-3030-303030303032 HT{ physical: 4000 w: 3 } -> \
   const Schema &projection = kProjectionForIteratorTests;
   const auto txn_context = TransactionOperationContext(
       TransactionId::GenerateRandom(), &txn_status_manager);
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   LOG(INFO) << "=============================================== ReadTime-2000";
   {
@@ -1905,7 +1905,7 @@ void DocRowwiseIteratorTest::TestScanWithinTheSameTxn() {
 
   const auto txn_context = TransactionOperationContext(*txn, &txn_status_manager);
   const Schema &projection = kProjectionForIteratorTests;
-  DocReadContext doc_read_context(kSchemaForIteratorTests, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(kSchemaForIteratorTests);
 
   auto iter = ASSERT_RESULT(CreateIterator(
       projection, doc_read_context, txn_context, doc_db(), CoarseTimePoint::max() /* deadline */,
@@ -1972,7 +1972,7 @@ void DocRowwiseIteratorTest::TestLargeKeys() {
   const Schema &projection = kProjectionForIteratorTests;
   QLTableRow row;
   QLValue value;
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -2046,7 +2046,7 @@ void DocRowwiseIteratorTest::TestPackedRow() {
   const Schema &projection = kProjectionForIteratorTests;
   QLTableRow row;
   QLValue value;
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
@@ -2133,7 +2133,7 @@ void DocRowwiseIteratorTest::TestDeletedDocumentUsingLivenessColumnDelete() {
   const Schema &projection = kProjectionForIteratorTests;
   QLTableRow row;
   QLValue value;
-  DocReadContext doc_read_context(schema, 1);
+  auto doc_read_context = DocReadContext::TEST_Create(schema);
 
   {
     auto iter = ASSERT_RESULT(CreateIterator(
diff --git a/src/yb/docdb/schema_packing.cc b/src/yb/docdb/schema_packing.cc
index 4cb2258cc046..988722ab64bc 100644
--- a/src/yb/docdb/schema_packing.cc
+++ b/src/yb/docdb/schema_packing.cc
@@ -255,5 +255,15 @@ bool SchemaPackingStorage::HasVersionBelow(SchemaVersion version) const {
   return false;
 }
 
+std::string SchemaPackingStorage::VersionsToString() const {
+  std::vector<SchemaVersion> versions;
+  versions.reserve(version_to_schema_packing_.size());
+  for (const auto& [version, schema] : version_to_schema_packing_) {
+    versions.push_back(version);
+  }
+  std::sort(versions.begin(), versions.end());
+  return AsString(versions);
+}
+
 } // namespace docdb
 } // namespace yb
diff --git a/src/yb/docdb/schema_packing.h b/src/yb/docdb/schema_packing.h
index 35f9c8df1767..b527152aca12 100644
--- a/src/yb/docdb/schema_packing.h
+++ b/src/yb/docdb/schema_packing.h
@@ -127,6 +127,8 @@ class SchemaPackingStorage {
     return version_to_schema_packing_.size();
   }
 
+  std::string VersionsToString() const;
+
   bool HasVersionBelow(SchemaVersion version) const;
 
   bool operator==(const SchemaPackingStorage&) const = default;
diff --git a/src/yb/master/sys_catalog.cc b/src/yb/master/sys_catalog.cc
index 866a0f0da0c7..b66e5a106d6d 100644
--- a/src/yb/master/sys_catalog.cc
+++ b/src/yb/master/sys_catalog.cc
@@ -148,7 +148,12 @@ DEFINE_test_flag(int32, sys_catalog_write_rejection_percentage, 0,
 namespace yb {
 namespace master {
 
+namespace {
+
 constexpr int32_t kDefaultMasterBlockCacheSizePercentage = 25;
+const std::string kLogPrefix = "system tablet: ";
+
+}
 
 std::string SysCatalogTable::schema_column_type() { return kSysCatalogTableColType; }
 
@@ -159,7 +164,7 @@ std::string SysCatalogTable::schema_column_metadata() { return kSysCatalogTableC
 SysCatalogTable::SysCatalogTable(Master* master, MetricRegistry* metrics,
                                  ElectedLeaderCallback leader_cb)
     : doc_read_context_(std::make_unique<docdb::DocReadContext>(
-          BuildTableSchema(), kSysCatalogSchemaVersion)),
+          kLogPrefix, BuildTableSchema(), kSysCatalogSchemaVersion)),
       metric_registry_(metrics),
       metric_entity_(METRIC_ENTITY_server.Instantiate(metric_registry_, "yb.master")),
       master_(master),
@@ -332,6 +337,7 @@ Status SysCatalogTable::CreateNew(FsManager *fs_manager) {
   DCHECK_EQ(1, partitions.size());
 
   auto table_info = std::make_shared<tablet::TableInfo>(
+      consensus::MakeTabletLogPrefix(kSysCatalogTabletId, fs_manager->uuid()),
       tablet::Primary::kTrue, kSysCatalogTableId, "", table_name(), TableType::YQL_TABLE_TYPE,
       schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */, partition_schema);
   string data_root_dir = fs_manager->GetDataRootDirs()[0];
diff --git a/src/yb/master/system_tablet.cc b/src/yb/master/system_tablet.cc
index 8b213828042b..ed5cf0a6b226 100644
--- a/src/yb/master/system_tablet.cc
+++ b/src/yb/master/system_tablet.cc
@@ -27,7 +27,9 @@ namespace master {
 
 SystemTablet::SystemTablet(const Schema& schema, std::unique_ptr<YQLVirtualTable> yql_virtual_table,
                            const TabletId& tablet_id)
-    : doc_read_context_(std::make_shared<docdb::DocReadContext>(schema, kSysCatalogSchemaVersion)),
+    : log_prefix_(Format("T $0: ", tablet_id)), // Don't have UUID here to log in T XX P YY format.
+      doc_read_context_(std::make_shared<docdb::DocReadContext>(
+          log_prefix_, schema, kSysCatalogSchemaVersion)),
       yql_virtual_table_(std::move(yql_virtual_table)),
       tablet_id_(tablet_id) {
 }
diff --git a/src/yb/master/system_tablet.h b/src/yb/master/system_tablet.h
index ce2c66ab7c8c..63dbbf11fcb6 100644
--- a/src/yb/master/system_tablet.h
+++ b/src/yb/master/system_tablet.h
@@ -97,6 +97,7 @@ class SystemTablet : public tablet::AbstractTablet {
       tablet::RequireLease require_lease, HybridTime min_allowed,
       CoarseTimePoint deadline) const override;
 
+  const std::string log_prefix_;
   docdb::DocReadContextPtr doc_read_context_;
   std::unique_ptr<YQLVirtualTable> yql_virtual_table_;
   TabletId tablet_id_;
diff --git a/src/yb/tablet/tablet-harness.cc b/src/yb/tablet/tablet-harness.cc
index cf6bf09e5745..0100b2357bad 100644
--- a/src/yb/tablet/tablet-harness.cc
+++ b/src/yb/tablet/tablet-harness.cc
@@ -53,8 +53,8 @@ Status TabletHarness::Create(bool first_time) {
   RETURN_NOT_OK(fs_manager_->CheckAndOpenFileSystemRoots());
 
   auto table_info = std::make_shared<TableInfo>(
-      Primary::kTrue, "YBTableTest", "test", "YBTableTest", options_.table_type, schema_,
-      IndexMap(), boost::none, 0 /* schema_version */, partition.first);
+      "test-tablet", Primary::kTrue, "YBTableTest", "test", "YBTableTest", options_.table_type,
+      schema_, IndexMap(), boost::none, 0 /* schema_version */, partition.first);
   auto metadata = VERIFY_RESULT(RaftGroupMetadata::TEST_LoadOrCreate(RaftGroupMetadataData {
     .fs_manager = fs_manager_.get(),
     .table_info = table_info,
diff --git a/src/yb/tablet/tablet.h b/src/yb/tablet/tablet.h
index 8313b094ef82..d757ed29152d 100644
--- a/src/yb/tablet/tablet.h
+++ b/src/yb/tablet/tablet.h
@@ -787,6 +787,8 @@ class Tablet : public AbstractTablet, public TransactionIntentApplier {
   // critical failures.
   Status ApplyAutoFlagsConfig(const AutoFlagsConfigPB& config);
 
+  std::string LogPrefix() const;
+
  private:
   friend class Iterator;
   friend class TabletPeerTest;
@@ -843,8 +845,6 @@ class Tablet : public AbstractTablet, public TransactionIntentApplier {
 
   Status DoEnableCompactions();
 
-  std::string LogPrefix() const;
-
   std::string LogPrefix(docdb::StorageDbType db_type) const;
 
   Result<bool> IsQueryOnlyForTablet(const PgsqlReadRequestPB& pgsql_read_request,
diff --git a/src/yb/tablet/tablet_bootstrap-test.cc b/src/yb/tablet/tablet_bootstrap-test.cc
index e88aad6a0a8b..77ee742ae4e1 100644
--- a/src/yb/tablet/tablet_bootstrap-test.cc
+++ b/src/yb/tablet/tablet_bootstrap-test.cc
@@ -179,8 +179,8 @@ class BootstrapTest : public LogTestBase {
     std::pair<PartitionSchema, Partition> partition = CreateDefaultPartition(schema);
 
     auto table_info = std::make_shared<TableInfo>(
-        Primary::kTrue, log::kTestTable, log::kTestNamespace, log::kTestTable, kTableType, schema,
-        IndexMap(), boost::none /* index_info */, 0 /* schema_version */, partition.first);
+        "TEST: ", Primary::kTrue, log::kTestTable, log::kTestNamespace, log::kTestTable, kTableType,
+        schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */, partition.first);
     auto result = VERIFY_RESULT(RaftGroupMetadata::TEST_LoadOrCreate(RaftGroupMetadataData {
       .fs_manager = fs_manager_.get(),
       .table_info = table_info,
diff --git a/src/yb/tablet/tablet_metadata.cc b/src/yb/tablet/tablet_metadata.cc
index 379036b7619a..6d76b8404cf9 100644
--- a/src/yb/tablet/tablet_metadata.cc
+++ b/src/yb/tablet/tablet_metadata.cc
@@ -95,8 +95,13 @@ Result<Uuid> ParseCotableId(Primary primary, const TableId& table_id) {
   return primary ? Uuid::Nil() : Uuid::FromHexString(table_id);
 }
 
+std::string MakeTableInfoLogPrefix(
+    const std::string& tablet_log_prefix, Primary primary, const TableId& table_id) {
+  return primary ? tablet_log_prefix : Format("TBL $0 $1", table_id, tablet_log_prefix);
 }
 
+} // namespace
+
 const int64 kNoDurableMemStore = -1;
 const std::string kIntentsSubdir = "intents";
 const std::string kIntentsDBSuffix = ".intents";
@@ -107,11 +112,12 @@ const std::string kSnapshotsDirSuffix = ".snapshots";
 // ============================================================================
 
 TableInfo::TableInfo()
-    : doc_read_context(new docdb::DocReadContext()),
+    : doc_read_context(new docdb::DocReadContext(log_prefix)),
       index_map(std::make_unique<IndexMap>()) {
 }
 
-TableInfo::TableInfo(Primary primary,
+TableInfo::TableInfo(const std::string& tablet_log_prefix,
+                     Primary primary,
                      std::string table_id_,
                      std::string namespace_name,
                      std::string table_name,
@@ -126,7 +132,8 @@ TableInfo::TableInfo(Primary primary,
       table_name(std::move(table_name)),
       table_type(table_type),
       cotable_id(CHECK_RESULT(ParseCotableId(primary, table_id))),
-      doc_read_context(std::make_unique<docdb::DocReadContext>(schema, schema_version)),
+      log_prefix(MakeTableInfoLogPrefix(tablet_log_prefix, primary, table_id)),
+      doc_read_context(std::make_unique<docdb::DocReadContext>(log_prefix, schema, schema_version)),
       index_map(std::make_unique<IndexMap>(index_map)),
       index_info(index_info ? new IndexInfo(*index_info) : nullptr),
       schema_version(schema_version),
@@ -143,6 +150,7 @@ TableInfo::TableInfo(const TableInfo& other,
       table_name(other.table_name),
       table_type(other.table_type),
       cotable_id(other.cotable_id),
+      log_prefix(other.log_prefix),
       doc_read_context(schema_version != other.schema_version
           ? std::make_unique<docdb::DocReadContext>(
               *other.doc_read_context, schema, schema_version)
@@ -161,6 +169,7 @@ TableInfo::TableInfo(const TableInfo& other, SchemaVersion min_schema_version)
       table_name(other.table_name),
       table_type(other.table_type),
       cotable_id(other.cotable_id),
+      log_prefix(other.log_prefix),
       doc_read_context(std::make_unique<docdb::DocReadContext>(
           *other.doc_read_context, std::min(min_schema_version, other.schema_version))),
       index_map(std::make_unique<IndexMap>(*other.index_map)),
@@ -172,13 +181,15 @@ TableInfo::TableInfo(const TableInfo& other, SchemaVersion min_schema_version)
 
 TableInfo::~TableInfo() = default;
 
-Status TableInfo::LoadFromPB(const TableId& primary_table_id, const TableInfoPB& pb) {
+Status TableInfo::LoadFromPB(
+    const std::string& tablet_log_prefix, const TableId& primary_table_id, const TableInfoPB& pb) {
   table_id = pb.table_id();
   namespace_name = pb.namespace_name();
   namespace_id = pb.namespace_id();
   table_name = pb.table_name();
   table_type = pb.table_type();
-  cotable_id = VERIFY_RESULT(ParseCotableId(Primary(primary_table_id == table_id), table_id));
+  Primary primary(primary_table_id == table_id);
+  cotable_id = VERIFY_RESULT(ParseCotableId(primary, table_id));
 
   RETURN_NOT_OK(doc_read_context->LoadFromPB(pb));
   if (pb.has_index_info()) {
@@ -199,6 +210,8 @@ Status TableInfo::LoadFromPB(const TableId& primary_table_id, const TableInfoPB&
     deleted_cols.push_back(col);
   }
 
+  log_prefix = MakeTableInfoLogPrefix(tablet_log_prefix, primary, table_id);
+
   return Status::OK();
 }
 
@@ -208,7 +221,7 @@ Status TableInfo::MergeWithRestored(
   // the schema version should already have been incremented to
   // match the snapshot.
   if (overwrite) {
-    LOG_IF(DFATAL, schema_version < pb.schema_version())
+    LOG_IF_WITH_PREFIX(DFATAL, schema_version < pb.schema_version())
         << "In order to merge schema packings during restore, "
         << "it is expected that schema version be at least "
         << pb.schema_version() << " for table " << table_id
@@ -219,7 +232,7 @@ Status TableInfo::MergeWithRestored(
   // the latest schema.
   const docdb::SchemaPacking& latest_packing = VERIFY_RESULT(
       doc_read_context->schema_packing_storage.GetPacking(schema_version));
-  LOG_IF(DFATAL, !latest_packing.SchemaContainsPacking(doc_read_context->schema))
+  LOG_IF_WITH_PREFIX(DFATAL, !latest_packing.SchemaContainsPacking(doc_read_context->schema))
       << "After merging schema packings during restore, latest schema does not"
       << " have the same packing as the corresponding latest packing for table "
       << table_id;
@@ -302,6 +315,7 @@ bool TableInfo::TEST_Equals(const TableInfo& lhs, const TableInfo& rhs) {
 }
 
 Status KvStoreInfo::LoadTablesFromPB(
+    const std::string& tablet_log_prefix,
     const google::protobuf::RepeatedPtrField<TableInfoPB>& pbs, const TableId& primary_table_id) {
   tables.clear();
   for (const auto& table_pb : pbs) {
@@ -309,7 +323,7 @@ Status KvStoreInfo::LoadTablesFromPB(
     TableInfoPtr& table_info =
         tables.emplace(table_id, std::make_shared<TableInfo>()).first->second;
 
-    RETURN_NOT_OK(table_info->LoadFromPB(primary_table_id, table_pb));
+    RETURN_NOT_OK(table_info->LoadFromPB(tablet_log_prefix, primary_table_id, table_pb));
 
     const Schema& schema = table_info->schema();
     if (table_id != primary_table_id) {
@@ -326,7 +340,8 @@ Status KvStoreInfo::LoadTablesFromPB(
   return Status::OK();
 }
 
-Status KvStoreInfo::LoadFromPB(const KvStoreInfoPB& pb,
+Status KvStoreInfo::LoadFromPB(const std::string& tablet_log_prefix,
+                               const KvStoreInfoPB& pb,
                                const TableId& primary_table_id,
                                bool local_superblock) {
   kv_store_id = KvStoreId(pb.kv_store_id());
@@ -342,7 +357,7 @@ Status KvStoreInfo::LoadFromPB(const KvStoreInfoPB& pb,
     snapshot_schedules.insert(VERIFY_RESULT(FullyDecodeSnapshotScheduleId(schedule_id)));
   }
 
-  return LoadTablesFromPB(pb.tables(), primary_table_id);
+  return LoadTablesFromPB(tablet_log_prefix, pb.tables(), primary_table_id);
 }
 
 Status KvStoreInfo::MergeWithRestored(
@@ -590,23 +605,23 @@ Status RaftGroupMetadata::DeleteTabletData(TabletDataState delete_type,
 
   rocksdb::Options rocksdb_options;
   TabletOptions tablet_options;
-  std::string log_prefix = consensus::MakeTabletLogPrefix(raft_group_id_, fs_manager_->uuid());
   docdb::InitRocksDBOptions(
-      &rocksdb_options, log_prefix, nullptr /* statistics */, tablet_options);
+      &rocksdb_options, log_prefix_, nullptr /* statistics */, tablet_options);
 
   const auto& rocksdb_dir = this->rocksdb_dir();
-  LOG(INFO) << "Destroying regular db at: " << rocksdb_dir;
+  LOG_WITH_PREFIX(INFO) << "Destroying regular db at: " << rocksdb_dir;
   rocksdb::Status status = rocksdb::DestroyDB(rocksdb_dir, rocksdb_options);
 
   if (!status.ok()) {
-    LOG(ERROR) << "Failed to destroy regular DB at: " << rocksdb_dir << ": " << status;
+    LOG_WITH_PREFIX(ERROR) << "Failed to destroy regular DB at: " << rocksdb_dir << ": " << status;
   } else {
-    LOG(INFO) << "Successfully destroyed regular DB at: " << rocksdb_dir;
+    LOG_WITH_PREFIX(INFO) << "Successfully destroyed regular DB at: " << rocksdb_dir;
   }
 
   if (fs_manager_->env()->FileExists(rocksdb_dir)) {
     auto s = fs_manager_->env()->DeleteRecursively(rocksdb_dir);
-    LOG_IF(WARNING, !s.ok()) << "Unable to delete rocksdb data directory " << rocksdb_dir;
+    LOG_IF_WITH_PREFIX(WARNING, !s.ok())
+        << "Unable to delete rocksdb data directory " << rocksdb_dir;
   }
 
   const auto intents_dir = this->intents_rocksdb_dir();
@@ -614,16 +629,16 @@ Status RaftGroupMetadata::DeleteTabletData(TabletDataState delete_type,
     status = rocksdb::DestroyDB(intents_dir, rocksdb_options);
 
     if (!status.ok()) {
-      LOG(ERROR) << "Failed to destroy provisional records DB at: " << intents_dir << ": "
-                 << status;
+      LOG_WITH_PREFIX(ERROR) << "Failed to destroy provisional records DB at: " << intents_dir
+                             << ": " << status;
     } else {
-      LOG(INFO) << "Successfully destroyed provisional records DB at: " << intents_dir;
+      LOG_WITH_PREFIX(INFO) << "Successfully destroyed provisional records DB at: " << intents_dir;
     }
   }
 
   if (fs_manager_->env()->FileExists(intents_dir)) {
     auto s = fs_manager_->env()->DeleteRecursively(intents_dir);
-    LOG_IF(WARNING, !s.ok()) << "Unable to delete intents directory " << intents_dir;
+    LOG_IF_WITH_PREFIX(WARNING, !s.ok()) << "Unable to delete intents directory " << intents_dir;
   }
 
   // TODO(tsplit): decide what to do with snapshots for split tablets that we delete after split.
@@ -631,7 +646,8 @@ Status RaftGroupMetadata::DeleteTabletData(TabletDataState delete_type,
   const auto snapshots_dir = this->snapshots_dir();
   if (fs_manager_->env()->FileExists(snapshots_dir)) {
     auto s = fs_manager_->env()->DeleteRecursively(snapshots_dir);
-    LOG_IF(WARNING, !s.ok()) << "Unable to delete snapshots directory " << snapshots_dir;
+    LOG_IF_WITH_PREFIX(WARNING, !s.ok())
+        << "Unable to delete snapshots directory " << snapshots_dir;
   }
 
   // Flushing will sync the new tablet_data_state_ to disk and will now also
@@ -684,7 +700,8 @@ RaftGroupMetadata::RaftGroupMetadata(
       tablet_data_state_(data.tablet_data_state),
       colocated_(data.colocated),
       cdc_min_replicated_index_(std::numeric_limits<int64_t>::max()),
-      cdc_sdk_min_checkpoint_op_id_(OpId::Invalid()) {
+      cdc_sdk_min_checkpoint_op_id_(OpId::Invalid()),
+      log_prefix_(consensus::MakeTabletLogPrefix(raft_group_id_, fs_manager_->uuid())) {
   CHECK(data.table_info->schema().has_column_ids());
   CHECK_GT(data.table_info->schema().num_key_columns(), 0);
   kv_store_.tables.emplace(primary_table_id_, data.table_info);
@@ -725,8 +742,8 @@ Status RaftGroupMetadata::LoadFromSuperBlock(const RaftGroupReplicaSuperBlockPB&
     return Flush();
   }
 
-  VLOG(2) << "Loading RaftGroupMetadata from SuperBlockPB:" << std::endl
-          << superblock.DebugString();
+  VLOG_WITH_PREFIX(2) << "Loading RaftGroupMetadata from SuperBlockPB:" << std::endl
+                      << superblock.DebugString();
 
   {
     std::lock_guard<MutexType> lock(data_mutex_);
@@ -743,9 +760,8 @@ Status RaftGroupMetadata::LoadFromSuperBlock(const RaftGroupReplicaSuperBlockPB&
     primary_table_id_ = superblock.primary_table_id();
     colocated_ = superblock.colocated();
 
-    RETURN_NOT_OK(kv_store_.LoadFromPB(superblock.kv_store(),
-                                       primary_table_id_,
-                                       local_superblock));
+    RETURN_NOT_OK(kv_store_.LoadFromPB(
+        log_prefix_, superblock.kv_store(), primary_table_id_, local_superblock));
 
     wal_dir_ = superblock.wal_dir();
     tablet_data_state_ = superblock.tablet_data_state();
@@ -994,7 +1010,8 @@ void RaftGroupMetadata::AddTable(const std::string& table_id,
                                  const SchemaVersion schema_version) {
   DCHECK(schema.has_column_ids());
   Primary primary(table_id == primary_table_id_);
-  TableInfoPtr new_table_info = std::make_shared<TableInfo>(primary,
+  TableInfoPtr new_table_info = std::make_shared<TableInfo>(log_prefix_,
+                                                            primary,
                                                             table_id,
                                                             namespace_name,
                                                             table_name,
@@ -1025,7 +1042,8 @@ void RaftGroupMetadata::AddTable(const std::string& table_id,
       // This must be the one-time migration with transactional DDL being turned on for the first
       // time on this cluster.
     } else {
-      LOG(DFATAL) << "Table " << table_id << " already exists. New table info: "
+      LOG_WITH_PREFIX(DFATAL)
+          << "Table " << table_id << " already exists. New table info: "
           << new_table_info->ToString() << ", old table info: " << existing_table.ToString();
 
       // We never expect colocation IDs to mismatch.
@@ -1199,8 +1217,8 @@ void RaftGroupMetadata::set_tablet_data_state(TabletDataState state) {
   tablet_data_state_ = state;
 }
 
-string RaftGroupMetadata::LogPrefix() const {
-  return consensus::MakeTabletLogPrefix(raft_group_id_, fs_manager_->uuid());
+const std::string& RaftGroupMetadata::LogPrefix() const {
+  return log_prefix_;
 }
 
 OpId RaftGroupMetadata::tombstone_last_logged_opid() const {
diff --git a/src/yb/tablet/tablet_metadata.h b/src/yb/tablet/tablet_metadata.h
index 2194996ab26b..2d01fe4c915c 100644
--- a/src/yb/tablet/tablet_metadata.h
+++ b/src/yb/tablet/tablet_metadata.h
@@ -88,6 +88,7 @@ struct TableInfo {
   TableType table_type;
   Uuid cotable_id; // table_id as Uuid
 
+  std::string log_prefix;
   // The table schema, secondary index map, index info (for index table only) and schema version.
   const std::unique_ptr<docdb::DocReadContext> doc_read_context;
   std::unique_ptr<IndexMap> index_map;
@@ -107,7 +108,8 @@ struct TableInfo {
   uint32_t wal_retention_secs = 0;
 
   TableInfo();
-  TableInfo(Primary primary,
+  TableInfo(const std::string& tablet_log_prefix,
+            Primary primary,
             std::string table_id,
             std::string namespace_name,
             std::string table_name,
@@ -125,7 +127,8 @@ struct TableInfo {
   TableInfo(const TableInfo& other, SchemaVersion min_schema_version);
   ~TableInfo();
 
-  Status LoadFromPB(const TableId& primary_table_id, const TableInfoPB& pb);
+  Status LoadFromPB(
+      const std::string& tablet_log_prefix, const TableId& primary_table_id, const TableInfoPB& pb);
   void ToPB(TableInfoPB* pb) const;
 
   std::string ToString() const {
@@ -142,6 +145,10 @@ struct TableInfo {
 
   Status MergeWithRestored(const TableInfoPB& pb, docdb::OverwriteSchemaPacking overwrite);
 
+  const std::string& LogPrefix() const {
+    return log_prefix;
+  }
+
   // Should account for every field in TableInfo.
   static bool TEST_Equals(const TableInfo& lhs, const TableInfo& rhs);
 };
@@ -158,7 +165,8 @@ struct KvStoreInfo {
         rocksdb_dir(rocksdb_dir_),
         snapshot_schedules(snapshot_schedules_.begin(), snapshot_schedules_.end()) {}
 
-  Status LoadFromPB(const KvStoreInfoPB& pb,
+  Status LoadFromPB(const std::string& tablet_log_prefix,
+                    const KvStoreInfoPB& pb,
                     const TableId& primary_table_id,
                     bool local_superblock);
 
@@ -166,6 +174,7 @@ struct KvStoreInfo {
       const KvStoreInfoPB& pb, bool colocated, docdb::OverwriteSchemaPacking overwrite);
 
   Status LoadTablesFromPB(
+      const std::string& tablet_log_prefix,
       const google::protobuf::RepeatedPtrField<TableInfoPB>& pbs, const TableId& primary_table_id);
 
   void ToPB(const TableId& primary_table_id, KvStoreInfoPB* pb) const;
@@ -502,7 +511,7 @@ class RaftGroupMetadata : public RefCountedThreadSafe<RaftGroupMetadata>,
   Result<std::string> TopSnapshotsDir() const;
 
   // Return standard "T xxx P yyy" log prefix.
-  std::string LogPrefix() const;
+  const std::string& LogPrefix() const;
 
   std::array<TabletId, kNumSplitParts> split_child_tablet_ids() const;
 
@@ -644,6 +653,8 @@ class RaftGroupMetadata : public RefCountedThreadSafe<RaftGroupMetadata>,
 
   std::vector<TxnSnapshotRestorationId> active_restorations_;
 
+  const std::string log_prefix_;
+
   DISALLOW_COPY_AND_ASSIGN(RaftGroupMetadata);
 };
 
diff --git a/src/yb/tools/yb-bulk_load.cc b/src/yb/tools/yb-bulk_load.cc
index 7f8d5219c461..a70055700c6d 100644
--- a/src/yb/tools/yb-bulk_load.cc
+++ b/src/yb/tools/yb-bulk_load.cc
@@ -329,7 +329,7 @@ Status BulkLoadTask::InsertRow(const string &row,
   // once we have secondary indexes we probably might need to ensure bulk load builds the indexes
   // as well.
   docdb::QLWriteOperation op(
-      req, std::make_shared<docdb::DocReadContext>(schema, schema_version),
+      req, std::make_shared<docdb::DocReadContext>("BULK LOAD: ", schema, schema_version),
       index_map, nullptr /* unique_index_key_schema */, TransactionOperationContext());
   RETURN_NOT_OK(op.Init(&resp));
   RETURN_NOT_OK(op.Apply(docdb::DocOperationApplyData{
diff --git a/src/yb/tserver/mini_tablet_server.cc b/src/yb/tserver/mini_tablet_server.cc
index 8a7330294bf9..797318eaa605 100644
--- a/src/yb/tserver/mini_tablet_server.cc
+++ b/src/yb/tserver/mini_tablet_server.cc
@@ -44,6 +44,7 @@
 #include "yb/common/schema.h"
 
 #include "yb/consensus/consensus.pb.h"
+#include "yb/consensus/consensus_util.h"
 
 #include "yb/encryption/encrypted_file_factory.h"
 #include "yb/encryption/header_manager_impl.h"
@@ -313,7 +314,8 @@ Status MiniTabletServer::AddTestTablet(const std::string& ns_id,
   pair<PartitionSchema, Partition> partition = tablet::CreateDefaultPartition(schema_with_ids);
 
   auto table_info = std::make_shared<tablet::TableInfo>(
-      tablet::Primary::kTrue, table_id, ns_id, table_id, table_type, schema_with_ids, IndexMap(),
+      consensus::MakeTabletLogPrefix(tablet_id, server_->permanent_uuid()), tablet::Primary::kTrue,
+      table_id, ns_id, table_id, table_type, schema_with_ids, IndexMap(),
       boost::none /* index_info */, 0 /* schema_version */, partition.first);
 
   return ResultToStatus(server_->tablet_manager()->CreateNewTablet(
diff --git a/src/yb/tserver/remote_bootstrap_client.cc b/src/yb/tserver/remote_bootstrap_client.cc
index 3b10f904a52c..7fc8b774a4f0 100644
--- a/src/yb/tserver/remote_bootstrap_client.cc
+++ b/src/yb/tserver/remote_bootstrap_client.cc
@@ -40,6 +40,7 @@
 
 #include "yb/consensus/consensus.h"
 #include "yb/consensus/consensus_meta.h"
+#include "yb/consensus/consensus_util.h"
 #include "yb/consensus/metadata.pb.h"
 
 #include "yb/fs/fs_manager.h"
@@ -347,6 +348,7 @@ Status RemoteBootstrapClient::Start(const string& bootstrap_peer_uuid,
                                               &wal_root_dir);
     }
     auto table_info = std::make_shared<tablet::TableInfo>(
+        consensus::MakeTabletLogPrefix(tablet_id_, fs_manager().uuid()),
         tablet::Primary::kTrue, table_id, table.namespace_name(), table.table_name(),
         table.table_type(), schema, IndexMap(table.indexes()),
         table.has_index_info() ? boost::optional<IndexInfo>(table.index_info()) : boost::none,
diff --git a/src/yb/tserver/tablet_server-test.cc b/src/yb/tserver/tablet_server-test.cc
index 04a05d1a722d..e4e026d6725e 100644
--- a/src/yb/tserver/tablet_server-test.cc
+++ b/src/yb/tserver/tablet_server-test.cc
@@ -860,8 +860,9 @@ TEST_F(TabletServerTest, TestWriteOutOfBounds) {
 
   Partition partition;
   auto table_info = std::make_shared<tablet::TableInfo>(
-      tablet::Primary::kTrue, "TestWriteOutOfBoundsTable", "test_ns", tabletId, YQL_TABLE_TYPE,
-      schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */, partition_schema);
+      "TEST: ", tablet::Primary::kTrue, "TestWriteOutOfBoundsTable", "test_ns", tabletId,
+      YQL_TABLE_TYPE, schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */,
+      partition_schema);
   ASSERT_OK(mini_server_->server()->tablet_manager()->CreateNewTablet(
       table_info, tabletId, partition, mini_server_->CreateLocalConfig()));
 
diff --git a/src/yb/tserver/tablet_service.cc b/src/yb/tserver/tablet_service.cc
index 9a7d6c7e09b4..b9b6ea79ca3a 100644
--- a/src/yb/tserver/tablet_service.cc
+++ b/src/yb/tserver/tablet_service.cc
@@ -50,6 +50,7 @@
 #include "yb/common/wire_protocol.h"
 #include "yb/consensus/leader_lease.h"
 #include "yb/consensus/consensus.pb.h"
+#include "yb/consensus/consensus_util.h"
 #include "yb/consensus/raft_consensus.h"
 
 #include "yb/docdb/cql_operation.h"
@@ -1369,6 +1370,7 @@ Status TabletServiceAdminImpl::DoCreateTablet(const CreateTabletRequestPB* req,
   VLOG(1) << "Full request: " << req->DebugString();
 
   auto table_info = std::make_shared<tablet::TableInfo>(
+      consensus::MakeTabletLogPrefix(req->tablet_id(), server_->permanent_uuid()),
       tablet::Primary::kTrue, req->table_id(), req->namespace_name(), req->table_name(),
       req->table_type(), schema, IndexMap(),
       req->has_index_info() ? boost::optional<IndexInfo>(req->index_info()) : boost::none,
diff --git a/src/yb/tserver/ts_tablet_manager-test.cc b/src/yb/tserver/ts_tablet_manager-test.cc
index 4b0e11ba709f..86a01f46c391 100644
--- a/src/yb/tserver/ts_tablet_manager-test.cc
+++ b/src/yb/tserver/ts_tablet_manager-test.cc
@@ -170,9 +170,9 @@ class TsTabletManagerTest : public YBTest {
     std::pair<PartitionSchema, Partition> partition = tablet::CreateDefaultPartition(full_schema);
 
     auto table_info = std::make_shared<tablet::TableInfo>(
-        tablet::Primary::kTrue, table_id, tablet_id, tablet_id, TableType::DEFAULT_TABLE_TYPE,
-        full_schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */,
-        partition.first);
+        "TEST: ", tablet::Primary::kTrue, table_id, tablet_id, tablet_id,
+        TableType::DEFAULT_TABLE_TYPE, full_schema, IndexMap(), boost::none /* index_info */,
+        0 /* schema_version */, partition.first);
     auto tablet_peer = VERIFY_RESULT(tablet_manager_->CreateNewTablet(
         table_info, tablet_id, partition.second, config_));
     if (out_tablet_peer) {
